
        processor 6502
        

        seg code                             ; NES Header
        org $7FF0                            ; and align PRG Code at $8000
        dc.b "NES",$1A,$02,$01,$01
        align $8000





PRG                         ; NES MOUSER ver 1.0 Copyright 1997 Tony Young
                SEI                 ; As for now, this code will remain undocumented.
                CLD                 ; It is rather messy and some sections of code 
main                        ; are unused even though they remain with this 
                LDA #00             ; source code because they were used during
                STA $209            ; the process of programming this ROM.
                LDA #01             ;
                STA $20A            ; Some of the names used as labels have nothing to
                LDA #135            ; do with the actual function of the subroutine
                STA $05             ; code following it, however, the purpose of most
                LDA #232            ; sections of code should be decipherable by 
                STA $04             ; anyone with a good understanding of 6502 code
                LDA #00             ; and the operation of the NES.
                STA $02             ;
                JSR ppuinit         ; Feel free to use this source as a learning tool
                JSR palette         ; and you may even expand upon it so long as you
                JSR attrib          ; follow the following guidelines:
                JSR fillzero        ; 
                JSR strtscrn        ; 1) All edited versions of this code must be
                LDA #$00            ;    e-mailed to TYoung79@aol.com prior to release
                STA $20A            ;
                LDA #$22            ; 2) If you find this code helpful or need help
                STA $209            ;    please e-mail me. Even if you don't need help
end                        ;    I must be compensated as well.
                JMP end                     ;
NMI                        ; This code was written for TASM.. after assembling
                STA $20B            ; with TASM (table assembler) using the -65 (6502)
                LDA #$01            ; and -g3 (binary instead of object format) options
                STA $20C            ; , This code can be inserted in a template ROM
                LDA #01             ; consisting of an NES header, a blank PRG ROM and 
                CMP $20A            ; a CHR ROM. After inserting, it must be assured 
                BEQ skipper         ; that all portions of the ROM are at the appropriate
                JSR sndinit         ; locations, the file is the proper length, and the
                JSR sounder         ; RESET & NMI vectors are placed in the appropriate 
                JSR mover           ; places at the end of the PRG ROM according to the
skipper                                  ; information given in Yoshi's technical document
                LDA $20B            ; please see http://nesdev.parodius.com for 
                RTI                 ; links to 6502 assembly language information and
                                    ; NES technical information

ppuinit
                LDA #$80         
                STA $2000         
                LDA #$1F       
                STA $2001        
                RTS
sndinit
                LDA #$1F          
                STA $4015
                LDA #$0F          
                STA $4000          
                STA $4004         
                STA $4008        
                LDA #$00          
                STA $4001         
                STA $4005        
                STA $4009         
                RTS
square1
                STX $4002         
                STY $4003         
                RTS
square2
                STX $4006        
                STY $4007       
                RTS
triangle
                STY $400B        
                RTS
palette
                LDA #$3F         
                STA $2006        
                LDA #$00           
                STA $2006          
                LDA #$01           
                STA $2007          
                LDA #$11         
                STA $2007         
                LDA #$12         
                STA $2007
                LDA #$13
                STA $2007
                LDA #$01
                STA $2007
                LDA #$14
                STA $2007
                LDA #$15
                STA $2007
                LDA #$16
                STA $2007
                LDA #$01
                STA $2007
                LDA #$17
                STA $2007
                LDA #$18
                STA $2007
                LDA #$19
                STA $2007
                LDA #$01
                STA $2007
                LDA #$0D
                STA $2007
                LDA #$2D
                STA $2007
                LDA #$3D
                STA $2007
                LDA #$01
                STA $2007
                LDA #$33
                STA $2007
                LDA #$3F
                STA $2007
                LDA #$2C
                STA $2007
                LDA #$01
                STA $2007
                LDA #$08
                STA $2007
                LDA #$18
                STA $2007
                LDA #$28
                STA $2007
                LDA #$01
                STA $2007
                LDA #$08
                STA $2007
                LDA #$09
                STA $2007
                LDA #$0A
                STA $2007
                LDA #$01
                STA $2007
                LDA #$0B
                STA $2007
                LDA #$0C
                STA $2007
                LDA #$0D
                STA $2007
                RTS
scroll
                STX $2005     
                STY $2005       
                RTS
hput
                STY $2007      
                DEX             
                CPX #$00
                BNE hput       
                RTS            
                       
put
                STY $2007      
                RTS
attrib
                LDA #$00
                STA $20C
anmi
                LDA #$01
                CMP $20C
                BNE anmi
        
                LDX #$00       
                LDA #$23        
                STA $2006       
                LDA #$C0       
                STA $2006       
lll
                LDA #$FF        
                STA $2007       
                INX             
                CPX #$40        
                BNE lll         
                RTS             
replines
                LDX #30
                LDY #$00
                JSR hput
                LDX #02
                LDY #$01
                JSR hput
                DEC $08
                CMP $08
                BNE replines
                LDX #31
                LDY #$01
                JSR hput
                RTS
beep                   
                LDX #$10
beeploop
                LDY #$FF
beeper
                DEY
                BNE beeper
                LDA #$02
                STX $4002
                STX $4006
                STX $400A 
                STA $4003
                STA $4007
                STA $400B
                INX
                CPX #$FF
                BNE beeploop
                RTS
sounder               
                STX $06       
                LDX $03         
                INX             
                STX $03         
                CPX #15         
                BNE noplay      
                LDX #$00        
                STX $03         
                LDX $02          
                LDA music,X     
                STA $4002        
                INX             
                LDA music,X     
                STA $4003       
                INX             
                LDA music,X     
                STA $4006       
                INX             
                LDA music,X     
                STA $4007       
                INX             
                LDA music,X     
                STA $400A       
                INX             
                LDA music,X     
                STA $400B       
                INX             
                CPX #192        
                BNE noreset     
                LDX #$00
noreset
                STX $02        
noplay
                LDX $06         
                RTS            
joya                 
                LDA #$01      
                STA $4016    
                LDA #$00      
                STA $4016     
                LDA $4016     
                AND #$01      
                RTS
joyb
                LDA #$01      
                STA $4016
                LDA #$00
                STA $4016
                LDA $4016
                LDA $4016     
                AND #$01
                RTS
joysel
                LDA #$01
                STA $4016
                LDA #$00
                STA $4016
                LDA $4016
                LDA $4016
                LDA $4016    
                AND #$01
                RTS
joyst
                LDA #$01
                STA $4016
                LDA #$00
                STA $4016
                LDA $4016
                LDA $4016
                LDA $4016
                LDA $4016    
                AND #$01
                RTS
joyup
                LDA #$01
                STA $4016
                LDA #$00
                STA $4016
                LDA $4016
                LDA $4016
                LDA $4016
                LDA $4016
                LDA $4016     
                AND #$01
                RTS
joydown
                LDA #$01
                STA $4016
                LDA #$00
                STA $4016
                LDA $4016
                LDA $4016
                LDA $4016
                LDA $4016
                LDA $4016
                LDA $4016    
                AND #$01
                RTS
joyleft
                LDA #$01
                STA $4016
                LDA #$00
                STA $4016
                LDA $4016
                LDA $4016
                LDA $4016
                LDA $4016
                LDA $4016
                LDA $4016
                LDA $4016    
                AND #$01
                RTS
joyright
                LDA #$01
                STA $4016
                LDA #$00
                STA $4016
                LDA $4016
                LDA $4016
                LDA $4016
                LDA $4016
                LDA $4016
                LDA $4016
                LDA $4016
                LDA $4016    
                AND #$01
                RTS
movesprite
                LDA #$00       
                STA $2003     
                STY $2004
                LDA #$03
                STA $2003
                STX $2004
                LDA #$01
                STA $2003
                LDX $100
                INX           
                STX $2004
                RTS
       
mover
                STA $200
                STX $201
                STY $202
                LDX $203
                INX
                CPX #3
                BEQ startr
                STX $203
                LDX $201
                RTS
startr
                LDX #00
                STX $203
                LDA #$22
                CMP $209
                BNE noob
                JSR dist
                LDA $207
                BEQ continu
                LDA #00
                STA $207
                JSR cheeser
                LDX $101
                INX
                STX $101
continu
                LDA $208
                CMP #$00
                BEQ noob
                JMP gameover
noob
                JSR joyup      
                BEQ aa        
                LDA #$01       
                STA $100       
aa                    
                JSR joydown    
                BEQ bb         
                LDA #$02        
                STA $100
bb
                JSR joyright
                BEQ cc
                LDA #$03
                STA $100
cc
                JSR joyleft
                BEQ dd
                LDA #$04
                STA $100
dd
                LDA #$01
                CMP $100
                BEQ moveup
                LDA #$02
                CMP $100
                BEQ movedown
                LDA #$03
                CMP $100
                BEQ moveright
                LDA #$04
                CMP $100
                BEQ moveleft
moveup
                LDX $101
                LDY $05
bup
                DEY
                DEX
                BNE bup 
                LDX $04
                STY $05
                JSR movesprite
                LDA $200
                LDX $201
                LDY $202
                RTS
movedown
                LDX $101
                LDY $05
bdn
                INY
                DEX
                BNE bdn
                LDX $04
                STY $05
                JSR movesprite
                LDA $200
                LDX $201
                LDY $202
                RTS
moveright
                LDY $101
                LDX $04
brt
                INX
                DEY
                BNE brt
                LDY $05
                STX $04
                JSR movesprite
                LDA $200
                LDX $201
                LDY $202
                RTS
moveleft
                LDY $101
                LDX $04
blt
                DEX
                DEY
                BNE blt
                LDY $05
                STX $04
                JSR movesprite
                LDA $200
                LDX $201
                LDY $202
                RTS
dist
                LDA $04
                SBC #$08
                LDX #$10
distl
                CMP $205
                BEQ distt
                ADC #1
                DEX
                BNE distl
                LDA #$00
                STA $207
                JMP oob
distt
                LDA $05
                SBC #$08
                LDX #$10
disttl
                CMP $206
                BEQ set
                ADC #1
                DEX
                BNE disttl
                LDA #$00
                STA $207
                JMP oob
set
                LDA #$01
                STA $207
      
oob
                 LDA #240
sl
                CMP $04
                BEQ setob
                ADC #01
                CMP $09
                BNE sl
                LDA #216
ssl
                CMP $05
                BEQ setob
                ADC #01
                CMP #17
                BNE ssl
                LDA #00
                STA $208
                RTS
setob
                LDA #01
                STA $208
                RTS
gameover
                LDA #01
                STA $20A
                LDA #$21
                STA $2006
                LDA #$CA
                STA $2006
                LDX #$10
nextabc
                STX $2007
                INX
                CPX #$19
                BNE nextabc
                JSR beep
lprpr
                JSR joya
                BEQ lprpr
                JMP main
strtscrn
                LDA #$00
                STA $204
                LDA #$0F
                STA $2001
                JSR drawstrt
                LDA #$00
                STA $20C
dnc
                LDA #$01
                CMP $20C
                BNE dnc

strtloop
                JSR joyst
                BEQ strtloop
                LDA #$1F
                STA $2001
                RTS
drawstrt
                LDY #$21
                STY $2006
                LDY #$28
                STY $2006
                LDY #$20
lplp
                STY $2007
                INY
                CPY #$30
                BNE lplp
                LDY #$21
                STY $2006
                LDY #$48
                STY $2006
                LDY #$30
lplpa
                STY $2007
                INY
                CPY #$40
                BNE lplpa
                LDY #$21
                STY $2006
                LDY #$88
                STY $2006
                LDY #$40
lplpb
                STY $2007
                INY
                CPY #$50
                BNE lplpb
                RTS
fillzero
                LDA #$20
                STA $2006
                LDA #$00
                STA $2006
                LDA #30
hh
                LDY #$06
                LDX #$20
                JSR hput
                SBC #1
                CMP #$00
                BNE hh
                RTS
cheese
                dc.b 40,20,80,60,130,140,20,100
                dc.b 200,50,40,100,135,130,140,75
                dc.b 80,90,90,120,200,85,75,95
        
        
music                          
                dc.b $B4,$10,$EF,$40,$B4,$40
                dc.b $B4,$10,$EF,$40,$B4,$40
                dc.b $A0,$20,$EF,$40,$B4,$40
                dc.b $B4,$10,$EF,$40,$B4,$40
                dc.b $B4,$10,$EF,$40,$B4,$40
                dc.b $B4,$10,$EF,$40,$B4,$40
                dc.b $A9,$20,$EF,$40,$B4,$40
                dc.b $B4,$10,$EF,$40,$B4,$40
                dc.b $B4,$10,$EF,$40,$B4,$40
                dc.b $B4,$10,$EF,$40,$B4,$40
                dc.b $8E,$10,$EF,$40,$B4,$40
                dc.b $B4,$10,$EF,$40,$B4,$40
                dc.b $A0,$10,$EF,$40,$B4,$40
                dc.b $B4,$10,$EF,$40,$B4,$40
                dc.b $A9,$10,0,0,$7F,$40
                dc.b $B4,$10,0,0,$78,$40
                dc.b $B4,$10,$D4,$40,$A0,$40
                dc.b $B4,$10,$D4,$40,$A0,$40
                dc.b $A0,$20,$D4,$40,$A0,$40
                dc.b $B4,$10,$D4,$40,$A0,$40
                dc.b $B4,$10,$D4,$40,$A0,$40
                dc.b $B4,$10,$D4,$40,$A0,$40
                dc.b $A9,$20,$D4,$40,$A0,$40
                dc.b $B4,$10,$D4,$40,$A0,$40
                dc.b $B4,$10,$D4,$40,$A0,$40
                dc.b $B4,$10,$D4,$40,$A0,$40
                dc.b $8E,$10,$D4,$40,$A0,$40
                dc.b $B4,$10,$D4,$40,$A0,$40
                dc.b $A0,$10,$D4,$40,$A0,$40
                dc.b $B4,$10,$D4,$40,$A0,$40
                dc.b $A9,$10,0,0,$7F,$40
                dc.b $B4,$10,0,0,$78,$40
              
                       

                   align $FFFA                          ; PRG Vector
                   dc.w NMI
                   dc.w PRG                             ; PRG Code starts at $8000
                   align $10000                          ; Fill with zeros until $C000
                   seg CHR                              ; CHR Bank
                   org $10000                            ; from $C000 to $E000
                   align $12000                          ; 8K


